local MinBuild, MaxBuild, Build = 40000, 0, select(4, GetBuildInfo())
if Build < MinBuild or ( MaxBuild > 0 and Build > MaxBuild ) then return end
local AddonName, a = ...
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables

local c = BittensSpellFlashLibrary2

local function flashHoly()
    a.Flash("Seal of Insight", "Beacon of Light")
    if not s.InCombat() then
        return
    end
    
    a.FlashAll("Judgement for Buff", "Fast Divine Light")
    a.Flash("Word of Glory at 3", "Holy Shock")
end

local function flashProtection()
    a.FlashAll("Righteous Fury", "Seal of Insight")
    if not s.InCombat() then
        return
    end
    
    a.Flash("Avenging Wrath")
    
    if a.Flash("Holy Wrath to Stun") then
        return
    end
    
    c.RotateCooldowns(
        { "Windwalk", "Veil of Lies" }, 
        "Holy Shield", 
        "Divine Protection", 
        "Fire of the Deep", 
        "Guardian of Ancient Kings", 
        "Ardent Defender")
    
    if a.Flash("Word of Glory at 90") then
        return
    end
    
    if a.hasThreeHolyPower()
        and s.HealthPercent("player") < 90 
        and c.GetCooldown("Word of Glory") < 1 then
            
        return
    end
    
    if a.Flash(
        "Vindication", 
        "Judgements of the Just",
        "Delayed Judgement",
        "Shield of the Righteous unless WoG",
        "Crusader Strike", 
        "Avenger's Shield for Holy Power") then
        
        return
    end
    
    if c.GetCooldown("Crusader Strike") < .5 then
        return
    end
    
    a.Flash(
        "Hammer of Wrath",
        "Avenger's Shield",
        "Consecration over 50",
        "Judgement",
        "Holy Wrath")
end

local function flashRetribution()
    a.Flash("Seal of Truth")
    if not s.InCombat() then
        return
    end

    a.FlashAll("Zealotry", "Avenging Wrath")
    
    a.Flash(
        "Inquisition",
        "Crusader Strike for Holy Power",
        "Free Exorsism against Undead",
        "Hammer of Wrath",
        "Free Exorsism",
        "Templar's Verdict",
        "Crusader Strike",
        "Judgement",
        "Holy Wrath",
        "Consecration over 50",
        "Divine Plea")
end

s.Spam[AddonName] = function()
    c.Init(AddonName, a)
    c.Run(
        { flashHoly, 1, "holy_off" },
        { flashProtection, 2, "prot_off" },
        { flashRetribution, 3, "ret_off" })
end
